SystemOrganization addCategory: #'AL-Tests-User'!

ALRelayTest subclass: #ALAuthenticationRelayTest
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Tests-User'!

!ALAuthenticationRelayTest methodsFor: 'running' stamp: 'cwp 7/13/2012 23:22'!
setUp
	super setUp.
	user := Object new.
! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 20:23'!
testGetOk
	| relay request resp |
	relay := ALAuthenticationRelay
		destination: self
		shunt: nil
		authenticator: self.
	request := ALRequest get: ALPath root.
	request addCookie: 'auth' value: 'giffle'.
	resp := relay handleRequest: request.
	self assert: resp == response.
	! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 20:17'!
testGetShunt
	| relay request resp |
	relay := ALAuthenticationRelay
		destination: nil
		shunt: self
		authenticator: self.
	request := ALRequest get: ALPath root.
	resp := relay handleRequest: request.
	self assert: resp == response.! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 20:21'!
testPostForbidden
	| relay request resp |
	relay := ALAuthenticationRelay
		destination: nil
		shunt: self
		authenticator: self.
	request := ALRequest method: 'POST' path: ALPath root.
	resp := relay handleRequest: request.
	self deny: resp == response.
	self assert: resp status = 403.! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 21:31'!
testPostOk
	| relay request resp |
	relay := ALAuthenticationRelay
		destination: self
		shunt: nil
		authenticator: self.
	request := ALRequest method: 'POST' path: ALPath root.
	request addCookie: 'auth' value: 'griffle'.
	resp := relay handleRequest: request.
	self assert: resp == response.
	! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 23:33'!
testUserRequestDuringDispatch
	| found relay request |
	relay := ALAuthenticationRelay
		destination: self
		shunt: nil
		authenticator: self.
	request := ALRequest get: ALPath root.
	request addCookie: 'auth' value: 'giffle'.
	handler := [found := ALUserRequest signal. response].
	relay handleRequest: request.
	self assert: found == user! !

!ALAuthenticationRelayTest methodsFor: 'tests' stamp: 'cwp 7/13/2012 23:44'!
testUserRequestDuringRender
	| found relay request |
	relay := ALAuthenticationRelay
		destination: self
		shunt: nil
		authenticator: self.
	request := ALRequest get: ALPath root.
	request addCookie: 'auth' value: 'giffle'.
	relay handleRequest: request.
	response writeEntityWith: [:ws | found := ALUserRequest signal].
	response writeInto: String new writing.
	self assert: found == user! !

!ALAuthenticationRelayTest methodsFor: 'authenticator' stamp: 'cwp 7/13/2012 20:29'!
userForToken: aString
	^ user! !
